//
//  API.m
//  DHSDKWrapper
//
//  Created by qq on 2019/9/9.
//  Copyright © 2019 yhy. All rights reserved.
//

#import "DHAPI.h"
#import "netsdk.h"

@implementation LoginForm
@end

@implementation LoginResult
@end

@implementation DHAPI
/// 登录
+ (void)IPLogin:(LoginForm*)form success:(void (^)(LoginResult* result))success
         failed:(void (^)(NSError* error))failed{
    
    char* szIP = (char*)[form.IP UTF8String];
    int nPort = [form.port intValue];
    char* szUser = (char*)[form.userName UTF8String];
    char* szPwd = (char*)[form.password UTF8String];
    EM_LOGIN_SPAC_CAP_TYPE emType = EM_LOGIN_SPEC_CAP_TCP;
    int nError = 0;
    NET_DEVICEINFO_Ex stInfo = {0};
    
    LoginResult* result = [LoginResult new];
    
    CLIENT_Init(cbDisConnect, (LDWORD)(__bridge void*)DHAPI.class);
    
   result.loginId = CLIENT_LoginEx2(szIP, nPort, szUser, szPwd, emType, NULL, &stInfo, &nError);
    if (result.loginId) {
        result.channel = stInfo.nChanNum;
        result.IP = form.IP;
        result.port = form.port;
        result.userName = form.userName;
        result.name = form.name;
        result.describe = form.describe;
        if(success){
            dispatch_async(dispatch_get_main_queue(), ^{
                
                success(result);
            });
        }
    }
    else {
        if(failed){
            dispatch_async(dispatch_get_main_queue(), ^{
                NSError* err = [DHAPI loginErrorWithCode:nError];
                failed(err);
            });
        }
    }
}
+(NSError*)loginErrorWithCode:(int)code{
    switch (code)
    {
            case 1:
            return [NSError errorWithDomain:@"APIError" code:901 userInfo:@{NSLocalizedDescriptionKey:@"密码错误"}];
            break;
            
            case 2:
            return [NSError errorWithDomain:@"APIError" code:902 userInfo:@{NSLocalizedDescriptionKey:@"用户名错误"}];
            break;
            
            case 3:
            return [NSError errorWithDomain:@"APIError" code:903 userInfo:@{NSLocalizedDescriptionKey:@"登录超时"}];
            break;
            
            case 4:
            return [NSError errorWithDomain:@"APIError" code:904 userInfo:@{NSLocalizedDescriptionKey:@"账号已登录"}];
            break;
            
            case 5:
            return [NSError errorWithDomain:@"APIError" code:905 userInfo:@{NSLocalizedDescriptionKey:@"账号被锁定"}];
            break;
            
            case 6:
            return [NSError errorWithDomain:@"APIError" code:906 userInfo:@{NSLocalizedDescriptionKey:@"账号被列入黑名单"}];
            break;
            
            case 7:
            return [NSError errorWithDomain:@"APIError" code:907 userInfo:@{NSLocalizedDescriptionKey:@"系统忙"}];
            break;
            
            case 10:
            return [NSError errorWithDomain:@"APIError" code:910 userInfo:@{NSLocalizedDescriptionKey:@"超过系统最大连接数"}];
            break;
            
        default:
            return [NSError errorWithDomain:@"APIError" code:906 userInfo:@{NSLocalizedDescriptionKey:@"连接失败"}];
            break;
    }
}
/// 退出登录
+ (void)loginOut:(LLONG)loginId{
    CLIENT_Logout(loginId);
}
/// 初始化句柄
void cbDisConnect(LLONG lLoginID, char *pchDVRIP, LONG nDVRPort, LDWORD dwUser)
{
    NSString* ip = [[NSString alloc] initWithUTF8String:pchDVRIP];
    NSString *str = [NSString stringWithFormat:@"设备 %@ 断开连接", ip];
    NSLog(@"%@",str);
    
}
@end
