//
//  LivePreviewViewController.m
//  NetSDK_Demo
//
//  Created by NetSDK on 2018/7/9.
//  Copyright © 2018年 NetSDK. All rights reserved.
//

#import "LivePreviewViewController.h"
#import "dhplay.h"
#import "VideoWnd.h"
#import "dhplayEx.h"
//#import "Global.h"
//#import "DHHudPrecess.h"
#import <fstream>
//#import "DHOptionViewController.h"
//#import "EncodeConfig.h"
#import "netsdk.h"
#import "configsdk.h"
#import "UIColor+Hex.h"
#import "GlobalDefine.h"
#import <Masonry.h>

static std::ofstream s_recordfile;
static LONG g_PlayPort = 0;
static BOOL m_bPlay = FALSE;
static BOOL m_bRecord = FALSE;


@interface LivePreviewViewController ()

@property (strong, nonatomic) UIButton *btnPlay;
@property (strong, nonatomic) UIView *m_TimetitleView;
@property (strong, nonatomic) VideoWnd *playWnd;
@property (strong, nonatomic) UIButton* btnClose;
@property (strong, nonatomic) UIView* vwDeviceInfo;


@property (nonatomic) int nChannel;
@property (nonatomic) int nStream;
@property (nonatomic) int nPreChannel;
@property (nonatomic) int nPreStream;
@property (nonatomic) int nPlayPort;
@property (nonatomic) long playHandle;

@property (nonatomic) UIButton *m_setEncodeConfig;
@property (nonatomic) NET_OSD_TIME_TITLE m_timeTitleInfo;
@property (nonatomic) NET_OSD_CHANNEL_TITLE m_channelTitleInfo;
@property (nonatomic) AV_CFG_ChannelName m_channelNameInfo;
@end

@implementation LivePreviewViewController


- (void)viewDidLoad {
    [super viewDidLoad];
    // init
    {
        _nChannel = 0;
        _nStream = 0;
        _nPreChannel = 0;
        _nPreStream = 0;
        _nPlayPort = 0;
        _playHandle = 0;
    }
    
    self.title = @"实时预览";
    self.view.backgroundColor = hex_color(0xf5f5f5);
    
    [self btnClose];

    [self playWnd];
//    [self btnPlay];
    [self vwDeviceInfo];
    
    // 添加手势
    UIPanGestureRecognizer *recognizer = [[UIPanGestureRecognizer alloc] initWithTarget:self action:@selector(handlePan:)];
    recognizer.minimumNumberOfTouches = 1;
    recognizer.maximumNumberOfTouches = 1;
    [self.playWnd addGestureRecognizer:recognizer];

    UIPinchGestureRecognizer* PinRecognizer = [[UIPinchGestureRecognizer alloc] initWithTarget:self action:@selector(PinRecognizerTap:)];
    [self.playWnd addGestureRecognizer:PinRecognizer];
    
    self.view.backgroundColor = hex_color(0x4a4f5e);
    
    [self onBtnPlay];
}
-(VideoWnd*)playWnd{
    if(!_playWnd){
        //play wiew
        _playWnd = [[VideoWnd alloc] init];
        _playWnd.backgroundColor = [UIColor whiteColor];//BASE_BACKGROUND_COLOR;

        _playWnd.layer.borderWidth = 1;
        [self.view addSubview:_playWnd];
        [_playWnd mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.mas_equalTo(self.btnClose.mas_bottom).offset(11);
            make.left.mas_equalTo(0);
            make.right.mas_equalTo(0);
            make.height.mas_equalTo(kScreenWidth*0.75);
        }];
    }
    return _playWnd;
}
-(UIButton*)btnClose{
    if (!_btnClose) {
        _btnClose = [UIButton buttonWithType:UIButtonTypeCustom];
        [_btnClose setImage:[UIImage imageNamed:@"back"] forState:UIControlStateNormal];
        [_btnClose addTarget:self action:@selector(onClose) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:_btnClose];
        
        [_btnClose mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.mas_equalTo(20);
            make.left.mas_equalTo(12);
            make.width.mas_equalTo(33);
            make.height.mas_equalTo(33);
        }];
    }
    return _btnClose;
}
-(UIButton*)btnPlay{
    if(!_btnPlay){
        _btnPlay = [[UIButton alloc] initWithFrame:CGRectMake(0, 0, kScreenWidth/4, kScreenHeight/20)];
        _btnPlay.backgroundColor = [UIColor lightGrayColor];
        [_btnPlay setTitle:@"播放" forState:UIControlStateNormal];
        [_btnPlay addTarget:self action:@selector(onBtnPlay) forControlEvents:UIControlEventTouchUpInside];
        [_btnPlay setTitleColor:UIColor.blackColor forState:UIControlStateNormal];
        _btnPlay.titleLabel.font = [UIFont systemFontOfSize:20];
        _btnPlay.titleLabel.adjustsFontSizeToFitWidth = TRUE;
        _btnPlay.layer.cornerRadius = 10;
        _btnPlay.layer.borderWidth = 1;
        
        [self.view addSubview:_btnPlay];
        
        [_btnPlay mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(0);
            make.bottom.mas_equalTo(-30);
            make.width.mas_equalTo(150);
            make.height.mas_equalTo(40);
        }];
    }
    return _btnPlay;
}
-(UIView*)vwDeviceInfo{
    if(!_vwDeviceInfo){
        _vwDeviceInfo = [UIView new];
        [self.view addSubview:_vwDeviceInfo];
        _vwDeviceInfo.layer.cornerRadius = 16;
        _vwDeviceInfo.clipsToBounds = YES;
        _vwDeviceInfo.backgroundColor = UIColor.whiteColor;
        [_vwDeviceInfo mas_makeConstraints:^(MASConstraintMaker *make) {
            make.top.mas_equalTo(self.playWnd.mas_bottom).offset(20);
            make.left.mas_equalTo(20);
            make.right.mas_equalTo(-20);
            make.bottom.mas_equalTo(-(20+safe_area_bottom_h));
        }];
        
        UIView* line = [UIView new];
        line.backgroundColor = hex_color(0xb1b1b1);
        [_vwDeviceInfo addSubview:line];
        [line mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(20);
            make.right.mas_equalTo(-20);
            make.height.mas_equalTo(1);
            make.centerY.mas_equalTo(self.vwDeviceInfo.mas_centerY);
        }];
        
        UILabel* lbDeviceName = [UILabel new];
        lbDeviceName.font = [UIFont systemFontOfSize:24];
        lbDeviceName.textColor = hex_color(0x757575);
        lbDeviceName.textAlignment = NSTextAlignmentCenter;
        lbDeviceName.text = _loginInfo.name;
        [_vwDeviceInfo addSubview:lbDeviceName];
        [lbDeviceName mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(20);
            make.right.mas_equalTo(-20);
            make.bottom.mas_equalTo(line.mas_top).offset(-30);
        }];
        
        UILabel* lbDeviceLocation = [UILabel new];
        lbDeviceLocation.font = [UIFont systemFontOfSize:15];
        lbDeviceLocation.textAlignment = NSTextAlignmentCenter;
        lbDeviceLocation.textColor = hex_color(0xb9b9b9);
        lbDeviceLocation.text = _loginInfo.describe;
        [_vwDeviceInfo addSubview:lbDeviceLocation];
        [lbDeviceLocation mas_makeConstraints:^(MASConstraintMaker *make) {
            make.left.mas_equalTo(20);
            make.right.mas_equalTo(-20);
            make.top.mas_equalTo(line.mas_bottom).offset(30);
        }];
        
    }
    return _vwDeviceInfo;
}

static void CALLBACK realDataCallback(LLONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, DWORD dwBufSize, LDWORD dwUser) {

    PLAY_InputData(g_PlayPort, pBuffer, dwBufSize);
    if (m_bRecord) {
        s_recordfile.write((char *)pBuffer, dwBufSize);
    }
}

-(void) viewDidAppear:(BOOL)animated {
    
}
- (void)onClose{
    if(m_bPlay){
        [self onBtnPlay];
    }
    [DHAPI loginOut:_loginInfo.loginId];
    
    [self dismissViewControllerAnimated:YES completion:nil];
}
- (void)onBtnPlay {
    
    if (FALSE ==  m_bPlay) {
        [self.playWnd setHidden:FALSE];
        PLAY_GetFreePort(&g_PlayPort);
        PLAY_OpenStream(g_PlayPort, nil, 0, 3*1024*1024);
        PLAY_Play(g_PlayPort, (__bridge void*)self.playWnd);
        PLAY_PlaySoundShare(g_PlayPort);
        
        DH_RealPlayType emStream = DH_RType_Realplay_0;
        if (0 == _nStream) {
            emStream = DH_RType_Realplay_0;
        }
        else {
            emStream = DH_RType_Realplay_1;
        }
        
        // 延迟播放
        if (0 == PLAY_SetDelayTime(g_PlayPort, 500, 1000)) {
           NSLog(@"%@", @"设置延迟播放失败");
        }
        _playHandle = CLIENT_RealPlayEx(_loginInfo.loginId, _nChannel, NULL, emStream);
        if (_playHandle) {
            CLIENT_SetRealDataCallBack(_playHandle, realDataCallback, (LDWORD)self);
            m_bPlay = TRUE;
            [_btnPlay setTitle:@"停止" forState:UIControlStateNormal];
            _btnPlay.backgroundColor = BASE_COLOR;
        }
        else {

        }
    }
    else {
        
        CLIENT_StopRealPlayEx(_playHandle);
        _playHandle = 0;
        PLAY_CleanScreen(g_PlayPort, 236/255.0, 236/255.0, 244/255.0, 1, 0);
        PLAY_StopSound();
        PLAY_Stop(g_PlayPort);
        PLAY_CloseStream(g_PlayPort);
        PLAY_ResetBuffer(g_PlayPort, 0);
        PLAY_ResetBuffer(g_PlayPort, 1);
        PLAY_ResetBuffer(g_PlayPort, 2);
        PLAY_ResetBuffer(g_PlayPort, 3);
        m_bPlay = FALSE;
        [_btnPlay setTitle:@"播放" forState:UIControlStateNormal];
        _btnPlay.backgroundColor = [UIColor lightGrayColor];
    }
}



-(void) PTZControl: (int) type :(BOOL) stop{
    int iChannel = _nChannel;
    BYTE param1= 0,param2 = 0;
    switch (type) {
        case DH_PTZ_UP_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_PTZ_DOWN_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_PTZ_RIGHT_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_PTZ_LEFT_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_PTZ_ZOOM_DEC_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_EXTPTZ_RIGHTDOWN:
            param1 = 4;
            param2 = 4;
            break;
        case DH_EXTPTZ_RIGHTTOP:
            param1 = 4;
            param2 = 4;
            break;
        case DH_EXTPTZ_LEFTDOWN:
            param1 = 4;
            param2 = 4;
            break;
        case DH_EXTPTZ_LEFTTOP:
            param1 = 4;
            param2 = 4;
            break;
        case DH_PTZ_ZOOM_ADD_CONTROL:
            param1 = 0;
            param2 = 4;
            break;
        case DH_PTZ_FOCUS_DEC_CONTROL:
            //Focus zoom in
            param1= 0;
            param2= 4;
            break;
        case DH_PTZ_FOCUS_ADD_CONTROL:
            //Focus zoom out
            param1= 0;
            param2= 4;
            break;
        case DH_PTZ_APERTURE_DEC_CONTROL:
            //Aperture zoom out
            param1= 0;
            param2= 4;
            break;
        case DH_PTZ_APERTURE_ADD_CONTROL:
            //Aperture zoom in
            param1= 0;
            param2= 4;
            break;
        default:
            break;
    }
    NSLog(@"channel:%d", iChannel);
    CLIENT_DHPTZControl(_loginInfo.loginId, iChannel, type, param1, param2, 0, stop);
}

-(void) handlePan: (UIPanGestureRecognizer*)recognizer {
    
    if (recognizer.state == UIGestureRecognizerStateBegan ||
        recognizer.state == UIGestureRecognizerStateChanged) {
        CGPoint v = [recognizer velocityInView:_playWnd];
        
        if (abs(v.x) + abs(v.y) < 100) {
            // velocity too small
            return;
        }
        
        int cmd = -1;
        float absTanV = fabs(v.y/v.x);
        
        if (absTanV < 0.33) {
            if (v.x > 0) {
                cmd = DH_PTZ_RIGHT_CONTROL;
            }
            else {
                cmd = DH_PTZ_LEFT_CONTROL;
            }
        }
        else if (absTanV > 3) {
            if (v.y > 0) {
                cmd = DH_PTZ_DOWN_CONTROL;
            }
            else {
                cmd = DH_PTZ_UP_CONTROL;
            }
        }
        else {
            if (v.x > 0 && v.y > 0) {
                cmd = DH_EXTPTZ_RIGHTDOWN;
            }
            else if (v.x < 0 && v.y > 0) {
                cmd = DH_EXTPTZ_LEFTDOWN;
            }
            else if (v.x > 0 && v.y < 0) {
                cmd = DH_EXTPTZ_RIGHTTOP;
            }
            else {
                cmd = DH_EXTPTZ_LEFTTOP;
            }
        }
        
        [self PTZControl:cmd:NO];
        usleep(100*1000);
        [self PTZControl:cmd:YES];
    }
}


- (void) PinRecognizerTap: (UIPinchGestureRecognizer*) PinRecognizer{
    NSLog(@"=======Pinch Tarch!=========");
    int cmd = -1;
    if (PinRecognizer.state == UIGestureRecognizerStateBegan ||
        PinRecognizer.state == UIGestureRecognizerStateChanged) {
        CGFloat scale = PinRecognizer.scale;
        NSLog(@"scale =====%f", scale);
        if (scale>1.0) {
            cmd = DH_PTZ_ZOOM_ADD_CONTROL;
        }
        if (scale<1.0) {
            cmd = DH_PTZ_ZOOM_DEC_CONTROL;
        }
    }
    [self PTZControl:cmd:NO];
    usleep(200*1000);
    [self PTZControl:cmd:YES];
    PinRecognizer.scale = 1.0;
    
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.

}

@end
