#import "ZhgdNativePlugin.h"
#import "DHAPI.h"
#import "LivePreviewViewController.h"

@implementation ZhgdNativePlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"origin_channel"
            binaryMessenger:[registrar messenger]];
  ZhgdNativePlugin* instance = [[ZhgdNativePlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"hello" isEqualToString:call.method]) {
      FlutterAppDelegate* delegate = (FlutterAppDelegate*)[[UIApplication sharedApplication]delegate];
      FlutterViewController* rootVC = (FlutterViewController*)delegate.window.rootViewController;
      
      LoginForm* form = [LoginForm new];
      form.IP = call.arguments[@"IP"];
      form.port = call.arguments[@"port"];
      form.userName = call.arguments[@"userName"];
      form.password = call.arguments[@"password"];
      form.name = call.arguments[@"name"];
      form.describe = call.arguments[@"describe"];
      
      [DHAPI IPLogin:form success:^(LoginResult * _Nonnull result) {
          NSLog(@"登录成功：loginID = %ld,channel = %d",result.loginId,result.channel);
          LivePreviewViewController* vc = [LivePreviewViewController new];
          vc.loginInfo = result;
          
          [rootVC presentViewController:vc animated:YES completion:nil];
          
      } failed:^(NSError * _Nonnull error) {
          NSLog(@"%@",error.localizedDescription);
      }];
  } else {
    result(FlutterMethodNotImplemented);
  }
}

@end
