#ifndef _DHPLAY_EX_H
#define _DHPLAY_EX_H

#include "dhplay.h"

#ifdef	__cplusplus
extern "C" {
#endif

/***********************************************************************************************/
/* 																					   */
/***********************************************************************************************/

#define PIC_BMP_32                      0       // BMP32
#define PIC_BMP_24                      1       // BMP24

/* SVAC */
#define SVC_LAYER_BASE					0x0001	// SVAC
#define SVC_LAYER_ENHANCE				0x0002	// SVACǿ
#define MAX_CUSTOM_EXT_COUNT            8
#define MAX_EXT_ROI_REGION_NUM          32		// ROIչĸ    
#define MAX_EXT_EVENT_REGION_NUM        32		// ¼չĸ
#define MAX_EXT_ALERT_NUM               32		// رչĸ
#define EXT_TYPE_ROI					0x0001  // ROIչ
#define EXT_TYPE_TIME					0x0002  // ʱչ
#define EXT_TYPE_ALERT					0x0004  // չ
#define EXT_TYPE_EVENT					0x0008  // ¼չ
#define EXT_TYPE_AUTH					0x0010  // ֤
#define EXT_TYPE_CUSTOM					0x1000  // Զչ

/* ΢SVAC */
#define ZXW_OSD_MAX_LEN					243     // ΢OSD_DATAַ
#define ZXW_OSD_TYPE_NUM				3       // ΢OSD࣬Ŀǰ֧֣ʱ䡢ͨصע
#define MAX_CAR_RECORD_NUM				20		// ˶ܽͨԼһδ
#define CAR_PLATE_CHARACTERS			11		// ַ
#define ID_NUMBER_CHAR					18		// ֤Ÿ
#define ID_NAME_CHAR					30		// ַ֤
#define ID_NATION_CHAR					24		// ַ
#define ID_BD_CHAR						16		// ַ
#define ID_ADDRESS_CHAR					70		// סַַ
#define ID_TIME_CHAR					19		// ʱַ
#define MAX_ID_CARD_NUM					20		// ׼δ涨ԶģҪ޸
#define MAX_MAC_WIFI_NUM				100		// macַĸöҪ޸
#define MAX_PG_NUM_RECORD				50		// ĿöҪ޸

/***********************************************************************************************/
/* ṹ嶨																				   */
/***********************************************************************************************/

/* Ϣ */
typedef struct __DATETIME_INFO
{
	unsigned int			nYear;			// 
	unsigned int			nMonth;			// 
	unsigned int			nDay;			// 
	unsigned int			nHour;			// ʱ
	unsigned int			nMinute;		// 
	unsigned int			nSecond;		// 
	unsigned int			nMilliSecond;	// 
}DATETIME_INFO;

/* 븽Ϣ */
typedef struct
{
	LONG			nVideoEncodeType;   // 
	LONG	        nDataLen;           // ݳ
	char*           pUserData;          // Ϣ,DEC_EXT_PARAM_SVAC
	LONG	        nReserved[2];
}FRAME_DEC_EXT_INFO;

/* SVAC븽ϢԶֶ */
typedef struct
{
	unsigned char type;             // Ϣ
	unsigned char length;           // Ϣ
	unsigned char *pbuf;            // Ϣָ
	unsigned char reserved[2];      // 
}DEC_EXT_INFO_CUSTOM;

typedef struct
{
	unsigned char subtype;					  // subtypeΪ32,33,34ʱʾձĵнͬһsubtypeչϢͬʱͬϢչϢʱһչϢǸǰһչϢ
	unsigned char codeType;					  // ʽǰ0ʹãʾʹUTF-8
	unsigned char alignType;				  // ʽ0Ϊ룬1ΪҶ
	unsigned char charSize;					  // Сرʾ
	unsigned char charType;					  // ַʽ0Ϊ׵׺ڱߣ1Ϊڵװױߣ2Ϊɫ壬3Ϊɫ
	unsigned short top_pixel;				  // λãرʾ 
	unsigned short left_pixel;				  // λãرʾ 
	unsigned char len;						  // ַ OSD_DATAռõֽ 
	unsigned char res[3];					  // 3ֽ 
	unsigned char OSD_DATA[ZXW_OSD_MAX_LEN];  // OSD ַݣ䳤 Len ȷ֧
											  // У'\n'ΪУ'\0'ΪͬʱҲַܵȵԼOSD_DATA
											  // Ϊ 243ֽ
}DEC_EXT_INFO_ZXW_OSD;

typedef struct
{
	unsigned char       m_iChannelID;         			// 
	unsigned char  		m_cPlate[CAR_PLATE_CHARACTERS];	// 
	unsigned char       m_iPlateColor;					// ɫ
	unsigned char       m_iPlateType;         			// 
	unsigned char 		m_iCarColor;          			// ɫ
	unsigned char   	m_iAlarmType;     				// 
	unsigned int     	m_iRedBeginTime;    			// ƿʼʱ䣬λ
	unsigned int     	m_iRedEndTime;      			// ƽʱ䣬λ
	unsigned char  		m_stCaptureTime[8];  			// ¼ľʱ ----ʱ---

}DEC_EXT_INFO_CAR_RECORD;

typedef struct{
	unsigned char    id_number[ID_NUMBER_CHAR]; // ֤ţASCIIʾ u[8*18]
	unsigned char    reserve;                   // һֽڳȵıַ
	unsigned char    name[ID_NAME_CHAR];        // GBK
	unsigned short   sex;                       // ԱGBK
	unsigned char    nation[ID_NATION_CHAR];    // GBK
	unsigned char    bD[ID_BD_CHAR];            // ڣá2016-12-08ASCIIʾδʹֽ
	unsigned char    address[ID_ADDRESS_CHAR];  // סַGBK
	unsigned char    time[ID_TIME_CHAR];        // Ϣʱ䣬á2016-12-08 10:52:45ASCIIʾ
}DEC_EXT_INFO_ID_CARD;

typedef struct{
	unsigned char           mac[6];         // macַ
	unsigned short          range;          // WIFIõͷľ룬λ
}DEC_EXT_INFO_MAC_WIFI;

typedef struct{
	int object_id;                 // Ŀ
	int top;                       // ΧϽ
	int left;                      // ΧϽǺ
	int bottom_diff;               // Χ½ϽĲֵ
	int right_diff;                // Χ½ǺϽǺĲֵ
	int bIsCrossLine;              // u(1)ǷԽ澯10
	int nCrossLineRgn;             // u(5)ĿԽ߶α
	int bIsCrossNet;               // u(1)Ƿָ澯10
	int nCrossNetRgn;              // u(3)Ŀ
	int nIsConverse;               // u(1)Ƿи澯10
	int nIndexConverse;            // u(2)Ŀ
}DEC_EXT_OBJECT_INFO;

typedef struct{
	unsigned char   ver0;			// 1汾
	unsigned char   ver1;			// 2汾
	int             rate_move_xy;	// ߶λϵcs,߶ֵcsλ
	int             bit_width;		// ߶ȱcn
	unsigned int    width;			// ԭʼͼ
	unsigned int    height;			// ԭʼͼ߶
	unsigned int    reserve0;		// ֽ
	unsigned int    reserve1;
	unsigned char   reserve2;   
	int             num_record;		// Ŀ
	DEC_EXT_OBJECT_INFO object_info[MAX_PG_NUM_RECORD]; // ĿϢ
}DEC_EXT_INFO_PERIMETER_GUARD;

typedef struct
{
	int flags;                              // չͱ

	int time_year;                          // ʱչ
	int time_month;
	int time_day;
	int time_hour;
	int time_minute;
	int time_second;
	int time_sec_fractional;
	int time_frame_num;

	int roi_region_num;                             // ROIչ
	int roi_top_left_x[MAX_EXT_ROI_REGION_NUM];     // ROIϽx
	int roi_top_left_y[MAX_EXT_ROI_REGION_NUM];     // ROIϽy
	int roi_width[MAX_EXT_ROI_REGION_NUM];          // ROI
	int roi_height[MAX_EXT_ROI_REGION_NUM];         // ROI߶

	int event_region_num;                           // ¼չ
	int event_num[MAX_EXT_EVENT_REGION_NUM];
	int event_region_event_id[MAX_EXT_EVENT_REGION_NUM][16];

	int alert_num;                                  // رչ
	int alert_region_id[MAX_EXT_ALERT_NUM];
	int alert_event_id[MAX_EXT_ALERT_NUM];
	int alert_frame_num[MAX_EXT_ALERT_NUM];

	int *auth_buf[2];                               // ֤buf, auth_buf[0]ǻ֤, auth_buf[1]ǿ֤
	int auth_len[2];                                // ֤ݳ, ֤ʱӦΪ 0
	int auth_signature_type[2];
	int auth_hash_hierarchy_flag[2];

	DEC_EXT_INFO_CUSTOM svac_ext_info_custom[MAX_CUSTOM_EXT_COUNT];			// չ
	DEC_EXT_INFO_ZXW_OSD svac_ext_info_zxw_osd[ZXW_OSD_TYPE_NUM];			// ΢OSDϢ

	int	car_record_num;	                                                    // ųĿ
	DEC_EXT_INFO_CAR_RECORD svac_ext_info_car_record[MAX_CAR_RECORD_NUM];   // ųϢ

	int id_card_num;                                                        // ֤
	DEC_EXT_INFO_ID_CARD    svac_ext_info_id_card[MAX_ID_CARD_NUM];         // ֤Ϣ

	int mac_wifi_num;                                                       // macϢ
	DEC_EXT_INFO_MAC_WIFI   svac_ext_info_mac_wifi[MAX_MAC_WIFI_NUM];       // wifiϢ

	DEC_EXT_INFO_PERIMETER_GUARD svac_ext_info_perimeter_guard;             // ܽԤϢ

}DEC_EXT_PARAM_SVAC;

/* ǿֵ֧Ĺ */
typedef enum 
{
	IVSEFUNCTYPE_DEHAZE,	    // ȥ
	IVSEFUNCTYPE_DENOISE,		// ȥ
	IVSEFUNCTYPE_WB,			// ƫɫУ
	IVSEFUNCTYPE_LOWLIGHT,		// նǿ
	IVSEFUNCTYPE_HDR,			// ̬
	IVSEFUNCTYPE_NUM			// ֧ǿĹܸ
}IVSEFUNCTYPE;

/* ROIͶ */
typedef struct
{
    int x;          // Ͻx
    int y;          // Ͻy
    int width;      // 
    int height;     // ߶
}IVSEROI;

/* Ƶǿ㷨 */
typedef struct
{
    IVSEFUNCTYPE eFuncType;				// ѡ
    IVSEROI		 cRoi;					// ROI 
	int			 nMode;					// 0ʾͼƬģʽ 1ʾƵģʽ
    int			 nProcess_param[2];     // Χ[1,5]
}IVSEPARAMS;

/***********************************************************************************************/
/* ӿ																						   */
/***********************************************************************************************/

/************************************************************************/
//> ļ
/************************************************************************/

/**
 * ļʼʱص
 *
 * @param[in] nPort		 ͨ
 * @param[in] nStartTime ļʼʱ.197011000
 * @param[in] nEndTime   ļʱ.197011000
 * @param[in] pUserData  û
 */
typedef void (CALLBACK* fFileTimeDoneCBFun)(LONG nPort, DWORD nStarTime, DWORD nEndTime, void* pUserData);

/**
 * ļʼʱص
 *
 * @param[in] nPort			     ͨ
 * @param[in] FileTimeDoneCBFun  صָ,ΪNULL
 * @param[in] pUserData          ûԶ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileTimeDoneCallBack(LONG nPort, fFileTimeDoneCBFun FileTimeCBFun, void* pUserData);

/**
 * ʱָλ֮ǰĹؼ֡λá
 *
 * @param[in] nPort		ͨ
 * @param[in] t			ʱ,SYSTEMTIME.õʱ.עִгɹֵ洢I֡ʱ
 * @param[in] framePos  ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetKeyFramePosByAbsTime(LONG nPort, SYSTEMTIME* t, FRAME_POS* framePos);

/**
 * ʱָλ֮Ĺؼ֡λá
 *
 * @param[in] nPort		ͨ
 * @param[in] t			ʱ,SYSTEMTIME.õʱ.עִгɹֵ洢I֡ʱ
 * @param[in] framePos  ҵĹؼ֡ļλϢṹָ,PFRAME_POS.
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetNextKeyFramePosByAbsTime(LONG nPort, SYSTEMTIME* t, FRAME_POS* framePos);

/**
 * ʱòʱ䡣
 *
 * @param[in] nPort		ͨ
 * @param[in] pDateTime	ʱ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayedAbsTime(LONG nPort, DATETIME_INFO *pDateTime);

/**
 * ļƫòλá
 *
 * @param[in] nPort		    ͨ
 * @param[in] nFileOffset	ļƫλ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayPosByFileOffset(LONG nPort, UINT nFileOffset);

/**
 * Ȼص
 *
 * @param[in] nPort				ͨ
 * @param[in] IndexProgressCB	ص
 * @param[in] pUser				û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef void (CALLBACK* fIndexProgressCB)(LONG nPort, float fProgress, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFileIndexProgressCallBack(LONG nPort, fIndexProgressCB IndexProgressCB, void* pUser);


/**
 * ȡI֡Ϣ
 *
 * @param[in] nPort		ͨ
 * @param[in] pBuffer	ַ
 * @param[in] pSize		С
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetIRefValue(LONG nPort, BYTE *pBuffer, DWORD *pSize);

/************************************************************************/
//> 
/************************************************************************/

/**
 * ȡƵͨ
 *
 * @param[in]  nPort	 ͨ
 * @param[out] pChannels [0-255]
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioChannels(LONG nPort, DWORD* pChannels);
 
/**
 * ѡƵͨ
 *
 * @param[in]  nPort	  ͨ
 * @param[in] nChannelID  Ƶͨ0ʼ
 * @param[in] bFlag       TRUE,FALSEر
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ChooseAudio(LONG nPort, DWORD nChannelID, BOOL bFlag);

/**
 * ȡƵͨ򿪹ر״̬
 *
 * @param[in]  nPort	   ͨ
 * @param[in]  nChannelID  Ƶͨ[0-255]
 * @param[out] bFlag       TRUE,FALSEر
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetAudioChooseState(LONG nPort, DWORD nChannelID, BOOL* bFlag);

/**
 * ƵţƵЧ
 *
 * @param[in]  nPort	   ͨ
 * @param[in]  nChnNum     ͨ0-ͨ1-ͨ
 * @param[in] bEnable      ʹ TRUE-ã FALSE-
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_EnableAudioChannel(LONG nPort, DWORD nChnNum, BOOL bEnable);

/************************************************************************/
//> ȡŻϢ
/************************************************************************/

/**
 * õǰ֡ʣ֧Сʽ
 *
 * @param[in] nPort ͨ
 * @return float ǰ֡
 */
PLAYSDK_API float CALLMETHOD PLAY_GetCurrentFrameRateEx(LONG nPort);

/**
 * ȡһ֡ӦYUVݡ
 *
 * @param[in] nPort ͨ
 * @param[in] pFrameDecodeInfo YUVϢ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetLastYUVFrame(LONG nPort, FRAME_DECODE_INFO* pFrameDecodeInfo);

/**
 * ¼ص
 *
 * @param[in] nPort					ͨ
 * @param[in] pFrameDecodeInfo      Ƶ
 * @param[in] pFrameInfo			ͼϢ,μFRAME_INFOṹ
 * @param[in] pDecodeProcessInfo    ڴ洢봦ɵ
 * @param[in] pUserData				û
 */
typedef struct 
{
	int nProcessType;			 // , DECODE_DATA_PROCESS_TYPEö
	unsigned char *pOutData;     // ݵĵַ
	unsigned int nOutDataLen;	 // ݵĳ
	unsigned int nOutDataBufLen; // ݵbuffer
}DECODE_DATA_PROCESS_INFO;
typedef void (CALLBACK* fDecodeDataProcessCB)(LONG nPort, FRAME_DECODE_INFO* pFrameDecodeInfo, FRAME_INFO_EX* pFrameInfo, DECODE_DATA_PROCESS_INFO *pDecodeProcessInfo, void* pUserData);

/**
 * ݻصӦ档
 *
 * @param[in] nPort            ͨ
 * @param[in] nProcessType     ݴ, DECODE_DATA_PROCESS_TYPE
 * @param[in] cbDecDataProcess صָ
 * @param[in] pUserData        û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef enum
{
	NO_PROCESS = 0,				// ޴
	PCM_MIX_PLAY = 1,			// Ƶ
}DECODE_DATA_PROCESS_TYPE;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeDataProcessCallBack(LONG nPort, int nProcessType, fDecodeDataProcessCB cbDecDataProcess, void* pUserData);

/**
 * ǩص
 *
 * @param[in] nPort		ͨ
 * @param[in] nFrameID  ֡
 * @param[in] bSuccess  УǷͨ
 * @param[in] pUserData	û
 */
typedef void (CALLBACK* fCheckDigitalSignCB)(LONG nPort, int nFrameID, BOOL bSuccess, void* pUserData);

/**
 * ǩص
 *
 * @param[in] nPort            ͨ
 * @param[in] pDigitalSignCB   ǩص
 * @param[in] pUserData        û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDigitalSignCallBack(LONG nPort, fCheckDigitalSignCB pDigitalSignCB, void* pUserData);

/**
 * ϢصSVACеЩϢ
 *
 * @param[in] nPort            ͨ
 * @param[in] DecInfoCallBack  Ϣصص
 * @param[in] pUserData        û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef void (CALLBACK* fMultiFrameDecCallBack)(LONG nPort, LONG nStreamID, char* pData, LONG nLen, 
												FRAME_INFO* stFrameInfo, void* pUserData, LONG nReserved1);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMultiFrameDecCallBack(LONG nPort, fMultiFrameDecCallBack DecInfoCallBack, void* pUserData);

/**
 * ֡ϢصSVAC
 *
 * @param[in] nPort            ͨ
 * @param[in] DecInfoCallBack  ֡Ϣصص
 * @param[in] pUserData        û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef void (CALLBACK* fDecInfoCallBack)(LONG nPort, FRAME_DEC_EXT_INFO* pDecInfo, void* pUserData, LONG nReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecInfoCallBack(LONG nPort, fDecInfoCallBack DecInfoCallBack, void* pUserData);

/**
 * Ƶ˽ָʹܡ
 *
 * @param[in] nPort            ͨ
 * @param[in] bRecover		   TRUE Ƶ˽ָ,FALSE Ƶ˽ڸ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPrivacyRecover(LONG nPort, BOOL bRecover);

/************************************************************************/
//> ͼ
/************************************************************************/

/**
 * Ƶȥ㷨ܡ
 *
 * @param[in] nPort            ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDeHaze(LONG nPort);

/**
 * Ƶȥ
 *
 * @param[in] nPort            ͨ
 * @param[in] ALightValue	   趨ĴǿֵΧ0-255
 * @param[in] AutoLightOn      ԶѰҴǿ0-رԶֶ, ĬΪ1
 * @param[in] AutoRun          һֱȥܣ0-ԶжǷ첢ȥĬΪ1
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDehazeParams(LONG nPort, int ALightValue, int AutoLightOn, int AutoRun);

/**
 * ֹͣƵȥ㷨ܡ
 *
 * @param[in] nPort            ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDeHaze(LONG nPort);

/**
 * Ƶǿ㷨ܡ
 *
 * @param[in] nPort            ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartIVSE(LONG nPort);

/**
 * ƵǿԶεʹöIVSEĹܡ
 *
 * @param[in] nPort            ͨ
 * @param[in] pIVSEParams      IVSEPARAMSṹ
 * @param[in] bEnable          ӦIVSEPARAMSеIVSEFUNCTYPEѡʹܿ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIVSEParams(LONG nPort, IVSEPARAMS* pIVSEParams, BOOL bEnable);

/**
 * ֹͣƵǿ㷨ܡ
 *
 * @param[in] nPort            ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopIVSE(LONG nPort);

/**
 * ͼ񻯴
 *
 * @param[in] nPort           ͨ
 * @param[in] level           ȼ,0-ر,6-ǿ,Ĭϵȼ4
 * @param[in] algMode         㷨ģʽ,Ԥӿ,Ŀǰֻ֧0
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartEdgeEnhance(LONG nPort, int level, int algMode);

/**
 * رͼ񻯴
 *
 * @param[in] nPort           ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopEdgeEnhance(LONG nPort);

/**
 * Ƶ
 *
 * @param[in] nPort           ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartVideoStable(LONG nPort);

/**
 * رƵ
 *
 * @param[in] nPort           ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopVideoStable(LONG nPort);

/************************************************************************/
//> ͬ
/************************************************************************/

/**
 * ͬš
 *
 * @return void*ͬſƾڵͬſƽӿʱҪþNULLʾʧ
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API void* CALLMETHOD PLAY_OpenPlayGroup();

/**
 * һ·ѾƵͬС
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] nPort       ҪͬŶеͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_AddToPlayGroup(void* hPlayGroup, LONG nPort);

/**
 * ͬŶɾָͨš
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] nPort       ͬŶɾͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_DelFromPlayGroup(void* hPlayGroup, LONG nPort);

/**
 * ӵǰʱŻ򵹷š
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] nDirection  ŷ 0ʾ1ʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayGroupDirection(void* hPlayGroup, int nDirection);

/**
 * òٶȡ
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] fSpeed  ٶȣΧ[1/64~64.0]С1ʾţ1ʾţٶȽϿʱܻ֡
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayGroupSpeed(void* hPlayGroup, float fSpeed);

/**
 * ͣ
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] bPause TRUEͣ,FLASEָ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_PausePlayGroup(void* hPlayGroup, BOOL bPause);

/**
 * ֡š
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StepPlayGroup(void* hPlayGroup);

/**
 * þʱжλ
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] pstDateTime ʱ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SeekPlayGroup(void* hPlayGroup, DATETIME_INFO* pstDateTime);

/**
 * ѯǰڲŵʱ䡣
 *
 * @param[in]  hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[out] pDateTime   ѯõʱ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_QueryGroupPlayingTime(void* hPlayGroup,  DATETIME_INFO *pDateTime);

/**
 * رͬſơ
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ClosePlayGroup(void* hPlayGroup);

/**
 * ͬŻ׼ͨ
 *
 * @param[in] hPlayGroup  ͬžPLAY_OpenPlayGroup
 * @param[in] nPort  ͬŻ׼ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetPlayGroupBaseChannel(void* hPlayGroup, LONG nPort);

/************************************************************************/
//> 
/************************************************************************/

/*  */
typedef struct
{
	int   himg_width;                       // ͼ
	int   himg_height;                      // ͼ
	int   *zoom_list;						// 
	int   zoom_list_size;					// λ
}MHFPTZ_INITPARAM;

/* ۽ */
typedef struct 
{
	int radius;						// ĿԲ뾶Ϊ8192ϵ
	int originX;					// ĿԲԲXΪ8192
	int originY;					// ĿԲԲYΪ8192
	FISHEYE_SIZE srcSize;			// ԲĿ
	FISHEYE_SIZE dstSize;			// ͼĿ
	int winId;						// Ŀ괰ڵid
	FISHEYE_MOUNTMODE mountMode;    // ۰װģʽ
	FISHEYE_CALIBRATMODE calibMode; // ģʽ
	FISHEYE_REGIONPARAM regionParam;// ͨFisheye_EptzUpdate FISHEYE_EPTZ_CMD_GET_CUR_REGION 

}FISHRECTIFY_INFO;

/**
 * չӿڡ
 *
 * @param[in] nPort				ͨ
 * @param[in] startType			ͣ 0ֻУ, 1ͬʱУ, 2ֻ㷨, 3ʾ180۽
 * @param[in] funcType			Щܣ0ʾ1ʾֻ֡ܣ2ʾֻץͼ3ʾ֡ץͼĹԽ࣬ĵڴԽ								
 * @param[in] ptzChannelParam	ʼͨstartTypeΪ0ʱptzChannelParamNULL
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartFisheyeEx(LONG nPort, int startType, int funcType, MHFPTZ_INITPARAM* ptzChannelParam);

/**
 * չӿڣ֧һ
 *
 * @param[in] nPort				ͨ
 * @param[in] startType			ͣ 0ֻУ, 1ͬʱУ, 2ֻ㷨, 3ʾ180۽
 * @param[in] funcType			Щܣ0ʾ1ʾֻ֡ܣ2ʾֻץͼ3ʾ֡ץͼĹԽ࣬ĵڴԽ								
 * @param[in] ptzChannelParam	ʼͨstartTypeΪ0ʱptzChannelParamNULL
 * @param[in] ptzChannelNum	    ʼͨ
 * @param[in] imgMaxOutput		ͼķֱ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartFisheyeMPTZ(LONG nPort, int startType, int funcType, MHFPTZ_INITPARAM* ptzChannelParam, int ptzChannelNum, FISHEYE_SIZE* pImgMaxOutput);


/**
 * ͼ꣬ԭʼԲԲꡣ
 *
 * @param[in]  param		FishRectify_Info
 * @param[in]  inrpt		㣬8192ϵ
 * @param[out] orpt			ת
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormCoordinate(FISHRECTIFY_INFO *param, FISHEYE_POINT2D* inrpt, FISHEYE_POINT2D *orpt);

/**
 * ͼ꣬ԭʼԲԲꡣ
 *
 * @param[in]     param		FishRectify_Info
 * @param[in]     rpt1		ͼϵһ㣬8192ϵ
 * @param[in]     rpt2		ͼϵһ㣬8192ϵ
 * @param[in/out] in_num	ĵ
 * @param[out]    fpts		ֵõĵУ˵㣬8192ϵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */		
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormCurve(FISHRECTIFY_INFO *param, FISHEYE_POINT2D* rpt1,FISHEYE_POINT2D* rpt2,int *in_num, FISHEYE_POINT2D *fpts);

/**
 * ͸ſǶȣſĽǶԽʾͼƬԽС
 *
 * @param[in]     nPort		 ͨ
 * @param[in]     nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]     fFovy		 ſĽǶȴС(0-180)
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStereoPerspectiveFovy(LONG nPort, DWORD nRegionNum, float fFovy);

/**
 * ͸ƶľ롣
 *
 * @param[in]     nPort		 ͨ
 * @param[in]     nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]     enMoveDicret		 ƶķ
 * @param[in]     fDistancefDistance ƶľ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
typedef enum
{
	STEREO_EYE_NO_MOVE = -1,                // ûƶ
	STEREO_EYE_MOVE_BACK,                   // ƶ
	STEREO_EYE_MOVE_RIGHT,                  // ƶ
	STEREO_EYE_MOVE_TOP,                    // ƶ
}STEREO_EYE_MOVE_DIRECTION;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStereoEyeMoveDistance(LONG nPort, DWORD nRegionNum, STEREO_EYE_MOVE_DIRECTION enMoveDicret, float fDistance);

/**
 * תĽǶȡ
 *
 * @param[in]     nPort		 ͨ
 * @param[in]     nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]     fXOffset	 xתĽǶȣ0-360ȣ
 * @param[in]     fYOffset   yתĽǶȣ0-360ȣ
 * @param[in]     fZOffset   zתĽǶȣ0-360ȣ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStereoRotate(LONG nPort, DWORD nRegionNum, float fXOffset, float fYOffset, float fZOffset);

/**
 * ĽǶȡ
 *
 * @param[in]     nPort		 ͨ
 * @param[in]     nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]     fXOffset	 Ϊԭ㣬Zᣨͷߣ˳ʱתĽǶ(ԶΪλ)
 * @param[in]     fYOffset   Ϊԭ㣬X˳ʱתĽǶ(ԶΪλ)
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStereoView(LONG nPort, DWORD nRegionNum, float fXOffset, float fYOffset);

/**
 * ù۲ģʽ
 *
 * @param[in]     nPort		 ͨ
 * @param[in]     nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]     enStereoViewMode	ͨŹ۲ģʽSTEREO_VIEW_MODE
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
typedef enum
{
	STEREO_COMMON_VIEW,                     // ͨģʽԿģ
	STEREO_INNER_VIEW,                      // ӵģʽ
}STEREO_VIEW_MODE;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetStereoViewMode(LONG nPort, DWORD nRegionNum, STEREO_VIEW_MODE enStereoViewMode);

/**
 * ʾģʽ
 *
 * @param[in]     nPort	   ͨ
 * @param[in]     mode     ģʽFISHEYE_CALIBRATMODE
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetCalibratMode(LONG nPort, FISHEYE_CALIBRATMODE mode);

/************************************************************************/
//> ץͼ
/************************************************************************/

/**
 * þʱͼƬ
 *
 * @param[in] filepath   ļ·
 * @param[in] time		 ʱ䣬timeNULLصһ֡
 * @param[in] fcbDec     ص
 * @param[in] pUserData  û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_GetTimePicture(const char* filepath, struct tm* time, fDecCBFun fcbDec, void* pUserData);

/**
 * ͼתΪBMPʽ
 *
 * @param[in] pBuf       ͼָ
 * @param[in] nSize		 ͼݴС
 * @param[in] nWidth     ͼ
 * @param[in] nHeight    ͼ߶
 * @param[in] nType       T_RGB32,T_UYVY
 * @param[in] sFileName  Ҫļ,.BMPΪչ
 * @param[in] nBmpType   BMP PIC_BMP_32ʾBMP32,PIC_BMP_24ʾBMP24
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ConvertToBmpFileEx(char * pBuf,LONG nSize,LONG nWidth,LONG nHeight,LONG nType, char *sFileName,int nBmpType);

/************************************************************************/
//> ¼ƻת빦
/************************************************************************/

/**
 * Ԥ¼Ļ
 *
 * @param[in] nPort ͨ
 * @param[in] nTime Ԥ¼ʱ䣬λ
 * @param[in] tmpDirectory ʱԤ¼Ŀ¼
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetupPrepareTime(LONG nPort,int nTime,const char* tmpDirectory);

/**
 * ʼԤ¼
 *
 * @param[in] nPort ͨ
 * @param[in] pFileName ¼λ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartPrepareRecord(LONG nPort,const char* pFileName);

/**
 * ֹͣԤ¼
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopPrepareRecord(LONG nPort);

/**
 * ʼֱʵAVIת
 *
 * @param[in] nPort ͨ
 * @param[in] sFileName ¼·
 * @param[in] lWidth  ĿĿ
 * @param[in] lHeight Ŀĸ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartAVIResizeConvert(LONG nPort, char *sFileName, LONG lWidth, LONG lHeight);

/**
 * ֱֹͣʵAVIת
 *
 * @param[in] nPort ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StopAVIResizeConvert(LONG nPort);

/**
 * ¼ص
 *
 * @param[in] nPort     ͨ
 * @param[in] pData     ָ
 * @param[in] nDataLen  ݳ
 * @param[in] nOffset   ʼƫλ, aviʽд,ⲿ谴մƫдļ, -1ʾֶЧ
 * @param[in] pUserData û
 */
typedef void (CALLBACK* fRecordDataCBFun)(LONG nPort, unsigned char* pData, int nDataLen, LONGLONG nOffset, void* pUserData);

/**
 * ʼ¼,ֻģʽ,PLAY_Play֮á
 * avi/mp4ֱֱ֧ת, PLAY_ResolutionScaleӿʹá
 *
 * @param[in] nPort      ͨ
 * @param[in] sFileName  ¼ļ,ļвڵļ,ʹļ
 * @param[in] idataType  ȡֵDATA_RECORD_TYPE
 * @param[in] fListenter ص
 * @param[in] pUserData  û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDataRecordEx(LONG nPort, char *sFileName, int idataType, fRecordDataCBFun fListenter, void* pUserData);

/************************************************************************/
//> 뼰ʾ
/************************************************************************/

/**
 * ͼţֻ֧ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  scale		ű[1.0, 8.0]
 * @param[out] nRegionNum   ʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Scale(LONG nPort, float scale, DWORD nRegionNum);

/**
 * ͼƽƣֻ֧ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  x			xƽֵ꣬		
 * @param[in]  y            yƽֵ꣬
 * @param[in]  nRegionNum   ʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Translate(LONG nPort, float x, float y, DWORD nRegionNum);

/**
 * ͼһƽƣŲֻ֧ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  nRegionNum   ʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetIdentity(LONG nPort, DWORD nRegionNum);

/**
 * ȡǰͼֵֻ֧ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  nRegionNum   ʾ
 * @return floatǰϵ
 */
PLAYSDK_API float CALLMETHOD PLAY_GetScale(LONG nPort, DWORD nRegionNum);

/**
 * ȡǰxƽֻ֧꣬ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  nRegionNum   ʾ
 * @return floatǰxƽ
 */
PLAYSDK_API float CALLMETHOD PLAY_GetTranslateX(LONG nPort, DWORD nRegionNum);

/**
 * ȡǰyƽֻ֧꣬ƽ̨
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  nRegionNum   ʾ
 * @return floatǰyƽ
 */
PLAYSDK_API float CALLMETHOD PLAY_GetTranslateY(LONG nPort, DWORD nRegionNum);

/**
 * ܣֻ֧ƽ̨PLAY_StopǰЧ
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  red			rgb
 * @param[in]  green	    rgb
 * @param[in]  blue			rgb
 * @param[in]  alpha	    alpha
 * @param[in]  nRegionNum   ʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_CleanScreen(LONG nPort, float red, float green, float blue, float alpha, DWORD nRegionNum);

/**
 * ѡʾSVACSVCĻǿ㡣
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  nFrameID		ҪʾĲ(0: 㣬1: ǿ)
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ChooseFrame(LONG nPort, LONG nFrameID);

/**
 * ʵֱųĿķֱȾ
 *
 * @param[in]  nPort	     ͨ
 * @param[in]  nTargetWidth	 Ŀķֱʿ
 * @param[in]  nTargetHeight Ŀķֱʸ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_ResolutionScale(LONG nPort, int nTargetWidth, int nTargetHeight);

/**
 * ļųˢһGOP
 *
 * @param[in]  nPort	     ͨ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_Flush(LONG nPort);

/**
 * òŻ󻺳֡
 *
 * @param[in]  nPort	 ͨ
 * @param[in]  nNum	     ֡[2,12]
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayBuf(LONG nPort,DWORD nNum);

/**
 * ûʾ,ֲŴʾʾڲ
 *
 * @param[in]  nPort	  ͨ
 * @param[in]  nRegionNum ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]  pSrcRect	  Ƶֲʾ,ΧΪ[0, Ƶ][0, Ƶ]
 * @param[in]  pDstRect	  ִʾ,ͻ
 * @param[in]  hDestWnd	  ʾھ
 * @param[in]  bEnable	  ()رʾ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayRegionEx(LONG nPort,DWORD nRegionNum, DISPLAYRECT *pSrcRect, DISPLAYRECT *pDstRect, HWND hDestWnd, BOOL bEnable);

/**
 * ۽ص
 *
 * @param[in] nPort		     ͨ
 * @param[in] pBuf           ָͨ
 * @param[in] nSize          ͨݳ
 * @param[in] nWidth	     ͨͼ
 * @param[in] nHeight	     ͨͼ
 * @param[in] pSecondBuf     ָͨ
 * @param[in] nSecondSize    ͨݳ
 * @param[in] nSecondWidth	 ͨͼ
 * @param[in] nSecondHeight	 ͨͼ
 * @param[in] pUserData  û
 */
typedef void (CALLBACK* fDoubleVisibleDecCBFun)(LONG nPort,char * pBuf, int nSize, int nWidth, int nHeight, 
													char* pSecondBuf, int nSecondSize, int nSecondWidth, int nSecondHeight, void* pUserData);
/**
 * ۽ص
 *
 * @param[in] nPort		 ͨ
 * @param[in] DataCBFun  ص
 * @param[in] pUserData  û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */												
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDoubleVisibleDecCallBack(LONG nPort, fDoubleVisibleDecCBFun DataCBFun, void* pUserData);

/**
 * ƴ㷨
 *
 * @param[in] nPort	 ͨ
 * @param[in] nMode  ģʽ0Ӧģʽ1Ӧ1+3ģʽ2Ӧ1+5ģʽ, 3Ӧ1+1ģʽӷŴ
 *					 4Ӧ1P+3, 5Ӧ1P+6, 6Ӧ1+1ģʽҵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SplitProc(LONG nPort, int nMode);

/**
 * ƴ㷨ҪŴľλá
 *
 * @param[in] nPort	 ͨ
 * @param[in] pAreaRect  ʼַ
 *			 nMode0ӦΪNULL
 *			 nMode1ĴСӦΪ3
  *			 nMode2ĴСӦΪ5 
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SplitProcUpdate(LONG nPort, DISPLAYRECT* pAreaRect);

/**
 * ʼܿ⡣
 *
 * @param[in] nPort	 ͨ
 * @param[in] kmcSvrIP    ipַ
 * @param[in] kmcSvrPort  ˿
 * @param[in] macAddr     macַ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_InitThirdPartyLibrary(LONG nPort, const char* kmcSvrIP,int kmcSvrPort,const char* macAddr);

/**
 * ý,롣
 *
 * @param[in] nPort	 ͨ
 * @param[in] nStrategyType   
 *				16: ʾframeǰ
 *				8 : ʾݲЭ鵱ɽ
 *				0 : ʾݲЭ룬Ứ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeStrategy(LONG nPort, int nStrategyType);

/**
 * Ƶ˲
 *
 * @param[in] nPort	 ͨ
 * @param[in] nMode  nModeȡ-1,0,1,2,3,4  
 *				-1:  
 *				0:   ĳ̶ͣźŵС
 *				4:   ĳ̶,źŵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetSEnhanceMode(LONG nPort,int nMode);

/**
 * չӿڡ
 *
 * @param[in] nPort	 ͨ
 * @param[in] decryptHook  ص 
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
enum ThirdDecryptType
{
	DECRYPT_KTJM = 4, // 
	DECRYPT_SYJM,	  // Ԫ
	DECRYPT_HZSD,     // ʦ㷨
	DECRYPT_ZBQL,     // б㷨
};
typedef struct 
{ 
	ThirdDecryptType type; // 
	BOOL (*Init)();		   // ʼӿ,ȫֳʼһ
	BOOL (*DeInit)();	   // ʼӿ
	void* (*Open)();	   // 򿪽ͨ, ֵΪ
	BOOL (*Decrypt)(void* handle, unsigned char* inData,  unsigned int inLen, unsigned char* outData, unsigned int* outLen);// , ԷֵҪ(1ɹ0ʧ)
	BOOL (*Close)(void* handle); // رսͨ
}ThirdDecryptHook;
PLAYSDK_API BOOL CALLMETHOD PLAY_Register3rdDecryptHook(ThirdDecryptHook* decryptHook);

/**
 * SVACԿ
 *
 * @param[in] nPort	   ͨ
 * @param[in] key      Կָ 
 * @param[in] key_len  Կ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDecodeKey(LONG nPort, const unsigned char *key, unsigned int key_len);

/************************************************************************/
//> ˽
/************************************************************************/

/* ļϢ֡ */
typedef struct __FILE_INFO_FRAME
{
	unsigned int		nFrameSubType;	  // ֡ͣ֡¼֡
	DATETIME_INFO*		pstDateTimeStart; // ʼʱ
	DATETIME_INFO*		pstDateTimeEnd;   // ʱ
	unsigned char*		pFrameData;		  // ֡
	unsigned int		nFrameDataLen;	  // ֡ݳ
} FILE_INFO_FRAME;

typedef struct __FILE_INFO_FRAME_SEARCH
{
#define PLAY_INFO_TYPE_MOTIONDECT     1    // 
#define PLAY_INFO_TYPE_EVENT		  2    // ¼
	unsigned int		nFileFrameType;	   // ͣϣ PLAYER_INFO_TYPE_MOTIONDECT | PLAYER_INFO_TYPE_EVENT
	DATETIME_INFO		stStartDataTime;   // ʼʱ
	DATETIME_INFO		stEndDataTime;     // ʱ
	DISPLAYRECT			rtDetectedRegion;  // еĶⷶΧ֡ʱЧΪ0ʱʾȫ
	DISPLAYRECT			rtTotal;		   // , ֡ʱЧ
} FILE_INFO_FRAME_SEARCH;

typedef struct __FILE_INFO_IMAGE
{
	tPicFormats	   imageType;			   // ͼƬ
	unsigned char* pPicBuf;				   // ͼƬĻָ
	unsigned int   nPicBufLen;			   // ͼƬĳ
} FILE_INFO_IMAGE;

/**
 * ļϢ֡ص
 */
typedef int (CALLBACK* fFileInfoFrameCBFun)(LONG nPort, FILE_INFO_IMAGE* pFileInfoImage, FILE_INFO_FRAME* pFileInfoFrame, void* pUserParam);
PLAYSDK_API BOOL CALLMETHOD	PLAY_SetFileInfoFrameCallback(LONG nPort, fFileInfoFrameCBFun fFileInfoFrame, tPicFormats imageType, void* pUserParam);

/**
 * ļϢ֡Ȼص
 */
typedef int (CALLBACK *fAnalyzePositionCBFun)(LONG nPort, DATETIME_INFO* pstDateTime, void* pUserParam);
PLAYSDK_API BOOL CALLMETHOD	PLAY_SetAnalyzePositionCallback(LONG nPort, fAnalyzePositionCBFun fAnalyzePosition, void* pUserParam);

/**
 * Ҫ֮󣬿ʼļϢ֡⣬
 */
PLAYSDK_API BOOL CALLMETHOD	PLAY_StartFileFrameDetect(LONG nPort, FILE_INFO_FRAME_SEARCH* pFileInfoFrameSearch);

/**
 * ֹ
 */
PLAYSDK_API BOOL CALLMETHOD	PLAY_StopFileFrameDetect(LONG nPort);

/**
 * ĿƵԴϢص
 *
 * @param[in] nPort		 ͨ
 * @param[in] pSensor    Ŀָ, mSensor*nSensorС
 * @param[in] mSensor    mԪ
 * @param[in] nSensor    nԪ
 * @param[in] nPicWidth  
 * @param[in] nPicHeight 
 * @param[in] pUserData  û
 */
typedef struct
{
	short leftTopX;
	short leftTopY;
	short rightBottomX;
	short rightBottomY;
}SensorInfo;
typedef void (CALLBACK* fSensorInfoCallBack)(LONG nPort, SensorInfo* pSensor, int mSensor, int nSensor, int nPicWidth, int nPicHeight, void* pUserData);

/**
 * öĿƵԴϢص
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  pCallBack	ص
 * @param[in]  pUserData    û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMultiSensorCallBack(LONG nPort, fSensorInfoCallBack pCallBack, void* pUserData);

/**
 * osdݻص
 *
 * @param[in] nPort		 ͨ
 * @param[in] pBuf       ָ
 * @param[in] nSize      ݳ
 * @param[in] pUserData  û
 */
typedef void (CALLBACK* fOSDInfoCallBackFun)(LONG nPort,char * pBuf,int nSize, void* pUserData);

/**
 * osdݻص
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  OSDInfoFun	ص
 * @param[in]  pUserData    û
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
PLAYSDK_API BOOL CALLMETHOD PLAY_SetOSDInfoCallBack(LONG nPort, fOSDInfoCallBackFun OSDInfoFun, void* pUserData);

/**
 * osdϢYUVӣWindowsЧ
 *
 * @param[in]  nPort	    ͨ
 * @param[in]  pOSDInfo	    osdϢ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */
#define OSD_ATTRIBUTE_FLAG_REGION   (1 << 0)
#define OSD_ATTRIBUTE_FLAG_EXTRA    (1 << 1)
#define OSD_ATTRIBUTE_FLAG_TIME	    (1 << 2)
#define MAX_REGION_NUMBER 128
typedef struct{
    unsigned int     attrflag;                    // ʹܱ
    unsigned char    region[MAX_REGION_NUMBER];   // Ϣ
    unsigned char    extra[MAX_REGION_NUMBER];    // Ϣ
    SYSTEMTIME       startTime;                   // ʼʱ
}YUV_OSD_INFO;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetYUVOSDInfo(LONG nPort, YUV_OSD_INFO* pOSDInfo);

/************************************************************************/
//> Ӳ
/************************************************************************/
/**
 * ѯtagϢ(Windows32ƽ̨)
 *
 * @param[in] nDiskNo ̺
 * @param[in] pTagInfo ѯtagϢⲿڴ
 * @param[in] nMaxLen TAG_INFOṹĸ
 * @return DWORDѯĿ
 */
typedef struct
{
	unsigned int    firstClusNo;
    DHTIME          timeStamp; 
    unsigned int    channel;   
    int             state;
    int             duration;
    char            reserved1[12]; 
    char            tagName[128];
    char            userName[128];
    char            channelName[128];
    char            reserved2[128];
    unsigned int    partNo;           	
}TAG_INFO;
PLAYSDK_API DWORD CALLMETHOD PLAY_QueryTagInfo(LONG nDiskNo, TAG_INFO* pTagInfo, DWORD nMaxLen);

/************************************************************************/
//> naclƽ̨ضӿ
/************************************************************************/
#ifdef __native_client__

#define FISHEYE_REGION 16
/**
 * ui߳Ⱦӿڡ
 *
 * @param[in]  nPort	 ͨ
 * @param[in]  nX        left
 * @param[in]  nY        top
 * @param[in] nWidth     ڿ
 * @param[in] nHeight    ڸ
 * @param[in] nRegionNum ʾţĬΪ0
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_OutsideRender(LONG nPort, int nX, int nY, int nWidth, int nHeight, unsigned int nRegionNum);

namespace pp
{
	class Instance;
}
/**
 * nacl̵߳ô˽ӿþַ
 *
 * @param[in]  pInstance pp::instanceַ 
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetNACLInstance(pp::Instance * pInstance);

#endif //__native_client__

/************************************************************************/
//> ͨ
/************************************************************************/

typedef enum GetSetType
{
	GRAPH   = 0x100,
	GRAPH_FORWARD_BACK_SWITCH_FRAMESEQ,		// ط޷л(֡)
	GRAPH_IFRAME_COSTTIME_ADJUST_FLAG,		// I֡ǷӦʱ,1:(֡*֡),0:(ԭʼ֡ʲ)
	SOURCE  = 0x200,
	DECODE  = 0x400,
	RENDER  = 0x800,
	RENDER_STEREO_PERSPECTIVE_FOVY,
	RENDER_STEREO_ROTATE_X,	
	RENDER_STEREO_ROTATE_Y,	
	RENDER_STEREO_ROTATE_Z,	
	RENDER_STEREO_EYE_MOVE_BACK,            // ǰƶ
	RENDER_STEREO_EYE_MOVE_RIGHT,           // ƶ
	RENDER_STEREO_EYE_MOVE_TOP,             // ƶ
	METHOD  = 0x1000,
	CBMgr   = 0x2000,
	ARENDER = 0x4000,
}GetSetType;

/**
 * Int32
 *
 * @param[in] nPort	   ͨ
 * @param[in] type      
 * @param[in] val      ͶӦֵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_SetInt32(LONG nPort, GetSetType type, int val);

/**
 * ȡInt32
 *
 * @param[in] nPort	     ͨ
 * @param[in] type        
 * @param[out] pval      ͶӦֵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_GetInt32(LONG nPort, GetSetType type, int* pVal);

/**
 * ȡDouble
 *
 * @param[in]  nPort	   ͨ
 * @param[in]  nRegionNum  ʾ,0~(MAX_DISPLAY_WND-1),Ϊ0,õʾ
 * @param[in]  type         
 * @param[out] pval        ͶӦֵ
 * @return BOOLɹTRUEʧܷFALSE
 * @note ʧܣԵPLAY_GetLastErrorExӿڻȡ롣
 */	
PLAYSDK_API BOOL CALLMETHOD PLAY_GetDoubleRegion(LONG nPort, DWORD nRegionNum, GetSetType type, double* pVal);

/************************************************************************/
//> Чӿ
/************************************************************************/

PLAYSDK_API BOOL CALLMETHOD PLAY_SetPandoraWaterMarkCallBack(LONG nPort, fGetWaterMarkInfoCallbackFunc pFunc, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_StartDeNoise(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDeNoiseParams(LONG nPort, int nTemporal);
PLAYSDK_API BOOL CALLMETHOD PLAY_StopDeNoise(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVideoPerTimer(int iVal);
PLAYSDK_API BOOL CALLMETHOD PLAY_GetVideoPerTimer(int* pVal);
PLAYSDK_API BOOL CALLMETHOD PLAY_InputVideoData(LONG nPort,PBYTE pBuf,DWORD nSize);
PLAYSDK_API BOOL CALLMETHOD PLAY_InputAudioData(LONG nPort,PBYTE pBuf,DWORD nSize);
typedef void (CALLBACK * fVerifyCBFun)(LONG nPort, FRAME_POS * pFilePos, DWORD bIsVideo, void* pUserData);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetVerifyCallBack(LONG nPort, DWORD nBeginTime, DWORD nEndTime, fVerifyCBFun VerifyFun, void* pUserData);
typedef void (CALLBACK * fSourceBufCBFun)(LONG nPort,DWORD nBufSize, void* pUserData,void*pResvered);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetSourceBufCallBack(LONG nPort,
													  DWORD nThreShold,
													  fSourceBufCBFun SourceBufCBFun,
													  void* pUserData,
													  void *pReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_ResetSourceBufFlag(LONG nPort);
PLAYSDK_API DWORD CALLMETHOD PLAY_GetDisplayBuf(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayType(LONG nPort,LONG nType);
PLAYSDK_API LONG CALLMETHOD PLAY_GetDisplayType(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_RefreshPlayEx(LONG nPort,DWORD nRegionNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_OpenStreamEx(LONG nPort,PBYTE pFileHeadBuf,DWORD nSize,DWORD nBufPoolSize);
PLAYSDK_API BOOL CALLMETHOD PLAY_CloseStreamEx(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_AdjustFluency(LONG nPort, int level);
PLAYSDK_API BOOL CALLMETHOD PLAY_SurfaceChange(LONG nPort, HWND hWnd);
PLAYSDK_API BOOL CALLMETHOD PLAY_ViewResolutionChanged(LONG nPort, int nWidth, int nHeight, DWORD nRegionNum);
typedef void (CALLBACK* fMultiFrameCallBack)(LONG nPort, LONG nStreamID, void* pUserData, LONG nReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMultiFrameCallBack(LONG nPort, fMultiFrameCallBack MultiFrameCallBack, void* pUser);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetRenderMode(LONG nPort, RenderType nMode);
typedef enum
{
	FISHSHOWMODE_WALL_PANORAMA = 0,       
	FISHSHOWMODE_CEIL_PANORAMA,          
	FISHSHOWMODE_CEIL_PANORAMA_TWO,       
	FISHSHOWMODE_FLOOR_PANORAMA,          
	FISHSHOWMODE_FLOOR_PANORAMA_TWO,      
	FISHSHOWMODE_ONE_O_THREE,            
	FISHSHOWMODE_CEIL_ONE_REGION = 10,    
	FISHSHOWMODE_CEIL_FOUR_REGION,        
	FISHSHOWMODE_ORIGINAL,               
	FISHSHOWMODE_WALL_ONE_REGION,         
	FISHSHOWMODE_WALL_FOUR_REGION,       
	FISHSHOWMODE_FLOOR_ONE_REGION,        
	FISHSHOWMODE_FLOOR_FOUR_REGION,       
	FISHSHOWMODE_WALL_ONE_O_THREE,	      
	FISHSHOWMODE_CEIL_ONE_O_THREE,	     
	FISHSHOWMODE_FLOOR_ONE_O_THREE,	     
}FISHSHOWMODES;
typedef enum
{
	FISHEPTZOPT_UPDATE_FOCUS,                   
	FISHEPTZOPT_ZOOM_IN,                        
	FISHEPTZOPT_ZOOM_OUT,                       
	FISHEPTZOPT_MOVE_UP,                       
	FISHEPTZOPT_MOVE_DOWN,                      
	FISHEPTZOPT_MOVE_LEFT,                      
	FISHEPTZOPT_MOVE_RIGHT,                     
	FISHEPTZOPT_AUTO_ROTATE_CLOCKWISE,          
	FISHEPTZOPT_AUTO_ROTATE_COUNTERCLOCKWISE,  
	FISHEPTZOPT_STOP_AUTO_ROTATE,				
	FISHEPTZOPT_GET_POSITION,					
	FISHEPTZOPT_SELECT_REGION_ZOOMIN_ON,       
	FISHEPTZOPT_SELECT_REGION_ZOOMIN_OFF,		
	FISHEPTZOPT_RESTORE_DEFAULT_LOCATION,		
}FISHEPTZOPTS;
PLAYSDK_API BOOL CALLMETHOD PLAY_SetFisheyeParams(LONG nPort, int nX, int nY, int nRadius, int nLensDirection, FISHSHOWMODES mode);
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeGetPosition(LONG nPort, int row, int column, int *pX, int *pY);
PLAYSDK_API BOOL CALLMETHOD PLAY_OldFisheyeEptzUpdate(LONG nPort, int *pX, int *pY, int *pHAngle, int *pVAngle, FISHEPTZOPTS ops, int nWinNum,
													  int nZoomStep, int nPtStep, int nRotateStep);
PLAYSDK_API BOOL CALLMETHOD PLAY_FisheyeTrancFormTrackFrame(LONG nPort, void *ptrackframe,int track_frame_size);
PLAYSDK_API BOOL CALLMETHOD PLAY_InitDDraw(HWND hWnd);
PLAYSDK_API int	CALLMETHOD PLAY_GetCaps();
PLAYSDK_API DWORD CALLMETHOD PLAY_GetFileHeadLength();
PLAYSDK_API BOOL CALLMETHOD PLAY_RealeseDDraw();
PLAYSDK_API DWORD CALLMETHOD PLAY_GetDDrawDeviceTotalNums();
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDDrawDevice(LONG nPort,DWORD nDeviceNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_GetDDrawDeviceInfo(DWORD nDeviceNum,LPSTR  lpDriverDescription,DWORD nDespLen,LPSTR lpDriverName ,DWORD nNameLen,LONG *hhMonitor);
PLAYSDK_API int	CALLMETHOD PLAY_GetCapsEx(DWORD nDDrawDeviceNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_ThrowBFrameNum(LONG nPort,DWORD nNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_InitDDrawDevice();
PLAYSDK_API void CALLMETHOD PLAY_ReleaseDDrawDevice();
PLAYSDK_API BOOL CALLMETHOD PLAY_Back(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDDrawDeviceEx(LONG nPort,DWORD nRegionNum,DWORD nDeviceNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetOverlayMode(LONG nPort,BOOL bOverlay,COLORREF colorKey);
PLAYSDK_API LONG CALLMETHOD PLAY_GetOverlayMode(LONG nPort);
PLAYSDK_API COLORREF CALLMETHOD PLAY_GetColorKey(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetTimerType(LONG nPort,DWORD nTimerType,DWORD nReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_GetTimerType(LONG nPort,DWORD *pTimerType,DWORD *pReserved);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMDRange(LONG nPort,DISPLAYRECT* rc,DWORD nVauleBegin,DWORD nValueEnd,DWORD nType);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMDThreShold(LONG nPort, DWORD ThreShold);
PLAYSDK_API DWORD CALLMETHOD PLAY_GetMDPosition(LONG nPort, DWORD Direction, DWORD nFrame, DWORD* MDValue);
typedef void (CALLBACK *CutProgressFunc)(DWORD nPort, int iProgress, DWORD dwUser);
PLAYSDK_API BOOL CALLMETHOD PLAY_CutFileSegment(LONG nPort, 
												LONG lBeginTime, 
												LONG lEndTime, 
												CutProgressFunc pFunc, 
												char *sOutFilePath, 
												DWORD dwUser);
PLAYSDK_API BOOL CALLMETHOD PLAY_ChangeRate(LONG nPort, int rate);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetDisplayScale(LONG nPort, float fScale, DWORD nRegionNum);
PLAYSDK_API BOOL CALLMETHOD PLAY_SetMemMinimized(LONG nPort);
PLAYSDK_API BOOL CALLMETHOD PLAY_EnableRecitfy(LONG nPort,BOOL bEnable);

#ifdef	__cplusplus
}
#endif

#endif


