/********************************************************************
*	File Name: 	        fsk.h	
*	Author:             qiao gang
*	Copyright 1992-2014, ZheJiang Dahua Technology Stock Co.Ltd.
* 						All Rights Reserved
*	Description:fsk㷨
*	Created:	        2014:09:23  18:50
*	Revision Record:    
*********************************************************************/

#ifndef _FSK_H
#define _FSK_H

#ifdef __cplusplus
extern "C" {
#endif

/*----------------------------------------*/
#ifdef _WIN32

    #ifndef FSK_LIB_EXPORTS
        #ifdef FSK_EXPORTS
#define FSK_API    __declspec(dllexport)
        #else
#define FSK_API    __declspec(dllimport)
        #endif
    #else
#define FSK_API
    #endif

#else

#define FSK_API

#endif
/*----------------------------------------*/

#include "audio_typedef.h"

/* The type of API parameters */
#undef  IN
#undef  INOUT
#undef  OUT
#define IN
#define INOUT
#define OUT

/* return enum */
typedef enum
{
	FSK_RX_END           =  2, /* յһ֡ݻʱ */
	FSK_RX_START         =  1, /* ʼһ֡ */
	/* ע⣺նÿεfsk_rxݹʱ׵  */
	/* FSK_RX_ENDFSK_RX_STARTֵû                      */
	FSK_RUN_OK           =  0, /* ȷִ                     */
	FSK_ALLOC_FAILED     = -1, /* ڴʧ                 */
	FSK_POINTER_NULL     = -2, /* ָΪ                     */
	FSK_IN_POINTER_NULL  = -3, /* ṹڲָΪ           */
	FSK_IN_LEN_ERROR     = -4, /* 볤ȴ                 */
	FSK_IN_CH_ERROR      = -5, /* ͨ               */
	FSK_IN_DEPTH_ERROR   = -6, /* ȴ             */
	FSK_IN_OFFSET_ERROR  = -7, /* Ƶ             */
	FSK_FREQ_ERROR       = -8, /* Ƶʴ                 */
    FSK_IN_SIZE_ERROR    = -9, /* С                 */
    FSK_IN_RTX_ERROR     = -10,/* 뷢ͽձ־         */
	FSK_OUT_OFFSET_ERROR = -11,/* Ƶ             */
	FSK_DATA_RATE_ERROR  = -12,/* շʴ             */
	FSK_RX_DATA_ERROR    = -13,/* ݴ                 */
	FSK_TONE_ERROR       = -14,/* ǰʲֱ֧   */
	FSK_BASE_FREQ_ERROR  = -15,/* Ƶô                 */
	FSK_RX_ERROR         = -16 /* ݽճ                 */
} FSK_RESULT;

typedef struct
{
	WORD32 frequency;  /* ƵƵʣλHz                                                                                  */
	WORD32 base_freq;  /* շźŻƵý£(עն˺ͷͶ˱ȣòն˺ͷͶ˶ʹ)                */
					   /* 44.1KHzϲʣ17000ʹòܱĳݣһͬʱ򿪱ʾ                  */
                       /*   32KHz²ʣ1000ʹÿԱ                                               */
	int    out_offset; /* Ƶ֮ļλֽڣòͶʹãն                            */
	int    data_rate;  /* շʣλbpsΪ300bps(עն˺ͷͶ˱ȣòն˺ͷͶ˶ʹ)         */
	int    fsk_ctrl;   /* Ʋã嶨£                                                                    */
                       /* bit-0  =0նˣ=1Ͷ                                                                         */
                       /* bit-2~1=00ޱʾ=01ʹĬϵıʾ񱳾ʱfrequency44.1KHz */
					   /* =10ʹԶıʾʱfrequencyڵ44.1KHzԶƵ16λPCMݣ*/
                       /* =ֵļʱԼΪ뷢ͺֽ*10/data_rateλ롣ñλͶʹ*/
                       /* ãն                                                                                      */
                       /* other bitsλ                                                                                      */
    AudioBuf bg_music; /* Զ屳ʾƵṹ壬ͶΪʹԶ屳ʾʱʹãն            */
} Fsk_Format;

/********************************************************************
*	Funcname: 	    	fsk_init
*	Purpose:	fsk㷨ڴͳʼ
*   InputParam:   INOUT Audio_Handle *phFsk:
*   OutputParam:        
*   Return:             FSK_RESULT
*   Created:	        2014:09:23  18:28
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_init( INOUT Audio_Handle *phFsk );

/********************************************************************
*	Funcname: 	    	fsk_setFormat
*	Purpose:	fsk㷨
*   InputParam:      IN Fsk_Format    *pFormat:fsk㷨
*   OutputParam:    OUT Audio_Handle  hFsk
*   Return:             FSK_RESULT
*   Created:	        2014:09:23  18:32
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_setFormat( OUT Audio_Handle hFsk, IN Fsk_Format *pFormat );

/********************************************************************
*	Funcname: 	    	fsk_getSize
*	Purpose:	ȡfsk_rxfsk_txڴСڿĵǰ
*               pFskOutputpAudioDst->pDataӦڴСλֽڡ
*               ע⣺1.úķֵڿڴ棬ȫֵܱʵֵһЩ
*                     2.fsk_initfsk_setFormatִк󣬲ܵøú
*   InputParam:   INOUT Audio_Handle hFsk
*                    IN int          input_size:ڷͱʾ뷢ͺֽfsk_txinLen
*                                               ڽձʾպPCMʱ(λ)
*                    IN int          rx_tx_flag:0-գ1-
*   OutputParam:    OUT int         *pOutLen   :ڴСλֽڡڷͱʾpAudioDst->pDataӦڴС
*                                               ڽձʾpFskOutputӦڴС
*   Return:             FSK_RESULT
*   Created:	        2015:08:06  17:09
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_getSize( OUT Audio_Handle hFsk, IN int input_size, IN int rx_tx_flag, OUT int *pOutSize );

/********************************************************************
*	Funcname: 	    	fsk_rx
*	Purpose:	fsk㷨ڴЧʿǣշδУ飬ϲЭмУֶΣ
*   InputParam:   INOUT Audio_Handle hFsk
*                    IN AudioBuf    *pAudioSrc :Ƶṹָ
*   OutputParam:    OUT WORD8       *pFskOutput:ս
*                   OUT int         *pOutLen   :ݳ
*   Return:             FSK_RESULT
*   Created:	        2014:09:23  18:35
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_rx( INOUT Audio_Handle hFsk, IN AudioBuf *pAudioSrc, OUT UWORD8 *pFskOutput, OUT int *pOutLen );

/********************************************************************
*	Funcname: 	    	fsk_tx
*	Purpose:	fsk㷨ڴЧʿǣշδУ飬ϲЭмУֶΣ
*   InputParam:   INOUT Audio_Handle hFsk
*                    IN WORD8       *pFskInput:뷢
*                    IN int          inLen    :뷢ֽЧֵ1 - 32767
*   OutputParam:    OUT AudioBuf    *pAudioDst:Ƶṹָ
*   Return:             FSK_RESULT
*   Created:	        2014:09:23  18:42
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_tx( INOUT Audio_Handle hFsk, IN UWORD8 *pFskInput, IN int inLen, OUT AudioBuf *pAudioDst );

/********************************************************************
*	Funcname: 	    	fsk_deInit
*	Purpose:	fsk㷨ڴ
*   InputParam:   INOUT Audio_Handle *phFsk
*   OutputParam:        
*   Return:             FSK_RESULT
*   Created:	        2014:09:23  18:31
*   Revision Record:    
*********************************************************************/
FSK_API FSK_RESULT fsk_deInit( INOUT Audio_Handle *phFsk );

#ifdef __cplusplus
}
#endif

#endif
